Loading...
Searching...
No Matches
casacore::RefColumn Class Reference
tables package (libcasa_tables) » Tables_module » Tables_module_internal_classes

More...

`#include <RefColumn.h>`

## Public Member Functions

| RefColumn (const BaseColumnDesc *, RefTable *, BaseColumn *referencedColumn)
| Construct the RefColumn.
| ~RefColumn ()
virtual Bool | isWritable () const
| Test if the column is writable in the parent table.
virtual Bool | isStored () const
| Test if the column is stored (otherwise it is virtual).
virtual TableRecord & | rwKeywordSet ()
| Get access to the column keyword set.
virtual TableRecord & | keywordSet ()
virtual rownr_t | nrow () const
| Get nr of rows in the column.
virtual Bool | isDefined (rownr_t rownr) const
| Test if a value in a particular cell has been defined.
virtual void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of the array in the given row.
virtual void | setShape (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of the array in the given row.
virtual uInt | ndimColumn () const
| Get the global #dimensions of an array (i.e.
virtual IPosition | shapeColumn () const
| Get the global shape of an array (i.e.
virtual uInt | ndim (rownr_t rownr) const
| Get the #dimensions of an array in a particular cell.
virtual IPosition | shape (rownr_t rownr) const
| Get the shape of an array in a particular cell.
virtual Bool | canChangeShape () const
| It can change shape if the underlying column can.
void | initialize (rownr_t startRownr, rownr_t endRownr)
| Initialize the rows from startRownr till endRownr (inclusive) with the default value defined in the column description (if defined).
virtual void | get (rownr_t rownr, void *dataPtr) const
| Get the value from a particular cell.
virtual void | getArray (rownr_t rownr, ArrayBase &dataPtr) const
| Get an array from a particular cell.
virtual void | getSlice (rownr_t rownr, const Slicer &, ArrayBase &dataPtr) const
| Get a slice of an N-dimensional array in a particular cell.
virtual void | getScalarColumn (ArrayBase &dataPtr) const
| Get the vector of all scalar values in a column.
virtual void | getArrayColumn (ArrayBase &dataPtr) const
| Get the array of all array values in a column.
virtual void | getColumnSlice (const Slicer &, ArrayBase &dataPtr) const
| Get subsections from all arrays in the column.
virtual void | getScalarColumnCells (const RefRows &rownrs, ArrayBase &dataPtr) const
| Get the vector of some scalar values in a column.
virtual void | getArrayColumnCells (const RefRows &rownrs, ArrayBase &dataPtr) const
| Get the array of some array values in a column.
virtual void | getColumnSliceCells (const RefRows &rownrs, const Slicer &, ArrayBase &dataPtr) const
| Get subsections from some arrays in the column.
virtual void | put (rownr_t rownr, const void *dataPtr)
| Put the value in a particular cell.
virtual void | putArray (rownr_t rownr, const ArrayBase &dataPtr)
| Put the array value in a particular cell.
virtual void | putSlice (rownr_t rownr, const Slicer &, const ArrayBase &dataPtr)
| Put a slice of an N-dimensional array in a particular cell.
virtual void | putScalarColumn (const ArrayBase &dataPtr)
| Put the vector of all scalar values in the column.
virtual void | putArrayColumn (const ArrayBase &dataPtr)
| Put the array of all array values in the column.
virtual void | putColumnSlice (const Slicer &, const ArrayBase &dataPtr)
| Put into subsections of all table arrays in the column.
virtual void | putScalarColumnCells (const RefRows &rownrs, const ArrayBase &dataPtr)
| Get the vector of some scalar values in a column.
virtual void | putArrayColumnCells (const RefRows &rownrs, const ArrayBase &dataPtr)
| Get the array of some array values in a column.
virtual void | putColumnSliceCells (const RefRows &rownrs, const Slicer &, const ArrayBase &dataPtr)
| Put subsections of some arrays in the column.
virtual ColumnCache & | columnCache ()
| Get the underlying column cache.
virtual void | setMaximumCacheSize (uInt nbytes)
| Set the maximum cache size (in bytes) to be used by a storage manager.
virtual void | makeSortKey (Sort &, std::shared_ptr< BaseCompare > &cmpObj, Int order, std::shared_ptr< ArrayBase > &dataSave)
| Add this column and its data to the Sort object.
virtual void | allocIterBuf (void *&lastVal, void *&curVal, std::shared_ptr< BaseCompare > &cmpObj)
| Allocate value buffers for the table iterator.
virtual void | freeIterBuf (void *&lastVal, void *&curVal)
| Free the value buffers allocated by allocIterBuf.
Public Member Functions inherited from casacore::BaseColumn
| BaseColumn (const BaseColumnDesc *)
| Construct it using the given column description.
virtual | ~BaseColumn ()
const ColumnDesc & | columnDesc () const
| Get const access to the column description.
virtual IPosition | tileShape (rownr_t rownr) const
| Get the tile shape of an array in a particular cell.
void | getScalar (rownr_t rownr, Bool &value) const
| Get the value from the row and convert it to the required type.
void | getScalar (rownr_t rownr, uChar &value) const
void | getScalar (rownr_t rownr, Short &value) const
void | getScalar (rownr_t rownr, uShort &value) const
void | getScalar (rownr_t rownr, Int &value) const
void | getScalar (rownr_t rownr, uInt &value) const
void | getScalar (rownr_t rownr, Int64 &value) const
void | getScalar (rownr_t rownr, float &value) const
void | getScalar (rownr_t rownr, double &value) const
void | getScalar (rownr_t rownr, Complex &value) const
void | getScalar (rownr_t rownr, DComplex &value) const
void | getScalar (rownr_t rownr, String &value) const
void | getScalar (rownr_t rownr, TableRecord &value) const
void | getScalar (rownr_t rownr, void *value, const String &dataTypeId) const
| Get a scalar for the other data types.
void | putScalar (rownr_t rownr, const Bool &value)
| Put the value into the row and convert it from the given type.
void | putScalar (rownr_t rownr, const uChar &value)
void | putScalar (rownr_t rownr, const Short &value)
void | putScalar (rownr_t rownr, const uShort &value)
void | putScalar (rownr_t rownr, const Int &value)
void | putScalar (rownr_t rownr, const uInt &value)
void | putScalar (rownr_t rownr, const Int64 &value)
void | putScalar (rownr_t rownr, const float &value)
void | putScalar (rownr_t rownr, const double &value)
void | putScalar (rownr_t rownr, const Complex &value)
void | putScalar (rownr_t rownr, const DComplex &value)
void | putScalar (rownr_t rownr, const String &value)
void | putScalar (rownr_t rownr, const Char *value)
void | putScalar (rownr_t rownr, const TableRecord &value)
virtual void | makeRefSortKey (Sort &, std::shared_ptr< BaseCompare > &cmpObj, Int order, const Vector< rownr_t > &rownrs, std::shared_ptr< ArrayBase > &dataSave)
| Do it only for the given row numbers.

## Protected Attributes

RefTable * | refTabPtr_p
BaseColumn * | colPtr_p
ColumnCache | colCache_p
Protected Attributes inherited from casacore::BaseColumn
const BaseColumnDesc * | colDescPtr_p

## Additional Inherited Members

Protected Member Functions inherited from casacore::BaseColumn
void | throwGetScalar () const
| Throw exceptions for invalid scalar get or put.
void | throwPutScalar () const
void | throwGetType (const String &type) const
void | throwPutType (const String &type) const

## Detailed Description

A column in a reference table

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- RefTable
- BaseColumn

### Etymology

RefTable represents a column in a RefTable. A RefTable is a table referencing another table, usually as the result of a select, etc..

### Synopsis

RefColumn handles the access of a column in a RefTable. It calls the corresponding function in the referenced column while converting the given row number to the row number in the referenced table.

### Motivation

This class is untyped, i.e. not templated. Every call is sent to the underlying referenced BaseColumn which is typed by the virtual function mechanism. A RefColumn can never be used directly. A user always has to construct a typed ArrayColumn or ScalarColumn object to access a column. This means everyting is fully type safe.

### To Do

- Act upon removal of rows or the underlying column

Definition at line 88 of file RefColumn.h.

## Constructor & Destructor Documentation

## RefColumn()

casacore::RefColumn::RefColumn | ( | const BaseColumnDesc * | ,
|  | RefTable * | ,
|  | BaseColumn * | referencedColumn )

Construct the RefColumn.

It will point to the given column description, RefTable and referenced column. The RefTable will be used to convert the rownr to the rownr in the referenced column.

References casacore::BaseColumn::BaseColumn().

## ~RefColumn()

casacore::RefColumn::~RefColumn | ( |  | ) |

## Member Function Documentation

## allocIterBuf()

virtual void casacore::RefColumn::allocIterBuf | ( | void *& | lastVal,
|  | void *& | curVal,
|  | std::shared_ptr< BaseCompare > & | cmpObj )

virtual

Allocate value buffers for the table iterator.

Also get a comparison functiuon if undefined. The function freeIterBuf must be called to free the buffers.

Reimplemented from casacore::BaseColumn.

## canChangeShape()

virtual Bool casacore::RefColumn::canChangeShape | ( |  | ) | const

virtual

It can change shape if the underlying column can.

Reimplemented from casacore::BaseColumn.

## columnCache()

virtual ColumnCache & casacore::RefColumn::columnCache | ( |  | ) |

virtual

Get the underlying column cache.

Implements casacore::BaseColumn.

## freeIterBuf()

virtual void casacore::RefColumn::freeIterBuf | ( | void *& | lastVal,
|  | void *& | curVal )

virtual

Free the value buffers allocated by allocIterBuf.

Reimplemented from casacore::BaseColumn.

## get()

virtual void casacore::RefColumn::get | ( | rownr_t | rownr,
|  | void * | dataPtr ) const

virtual

Get the value from a particular cell.

This can be a scalar or an array.

Reimplemented from casacore::BaseColumn.

## getArray()

virtual void casacore::RefColumn::getArray | ( | rownr_t | rownr,
|  | ArrayBase & | dataPtr ) const

virtual

Get an array from a particular cell.

Reimplemented from casacore::BaseColumn.

## getArrayColumn()

virtual void casacore::RefColumn::getArrayColumn | ( | ArrayBase & | dataPtr | ) | const

virtual

Get the array of all array values in a column.

If the column contains n-dim arrays, the resulting array is (n+1)-dim. The arrays in the column have to have the same shape in all cells.

Reimplemented from casacore::BaseColumn.

## getArrayColumnCells()

virtual void casacore::RefColumn::getArrayColumnCells | ( | const RefRows & | rownrs,
|  | ArrayBase & | dataPtr ) const

virtual

Get the array of some array values in a column.

If the column contains n-dim arrays, the resulting array is (n+1)-dim. The arrays in the column have to have the same shape in all cells.

Reimplemented from casacore::BaseColumn.

## getColumnSlice()

virtual void casacore::RefColumn::getColumnSlice | ( | const Slicer & | ,
|  | ArrayBase & | dataPtr ) const

virtual

Get subsections from all arrays in the column.

If the column contains n-dim arrays, the resulting array is (n+1)-dim. The arrays in the column have to have the same shape in all cells.

Reimplemented from casacore::BaseColumn.

## getColumnSliceCells()

virtual void casacore::RefColumn::getColumnSliceCells | ( | const RefRows & | rownrs,
|  | const Slicer & | ,
|  | ArrayBase & | dataPtr ) const

virtual

Get subsections from some arrays in the column.

If the column contains n-dim arrays, the resulting array is (n+1)-dim. The arrays in the column have to have the same shape in all cells.

Reimplemented from casacore::BaseColumn.

## getScalarColumn()

virtual void casacore::RefColumn::getScalarColumn | ( | ArrayBase & | dataPtr | ) | const

virtual

Get the vector of all scalar values in a column.

Reimplemented from casacore::BaseColumn.

## getScalarColumnCells()

virtual void casacore::RefColumn::getScalarColumnCells | ( | const RefRows & | rownrs,
|  | ArrayBase & | dataPtr ) const

virtual

Get the vector of some scalar values in a column.

Reimplemented from casacore::BaseColumn.

## getSlice()

virtual void casacore::RefColumn::getSlice | ( | rownr_t | rownr,
|  | const Slicer & | ,
|  | ArrayBase & | dataPtr ) const

virtual

Get a slice of an N-dimensional array in a particular cell.

Reimplemented from casacore::BaseColumn.

## initialize()

void casacore::RefColumn::initialize | ( | rownr_t | startRownr,
|  | rownr_t | endRownr )

virtual

Initialize the rows from startRownr till endRownr (inclusive) with the default value defined in the column description (if defined).

Implements casacore::BaseColumn.

## isDefined()

virtual Bool casacore::RefColumn::isDefined | ( | rownr_t | rownr | ) | const

virtual

Test if a value in a particular cell has been defined.

Implements casacore::BaseColumn.

## isStored()

virtual Bool casacore::RefColumn::isStored | ( |  | ) | const

virtual

Test if the column is stored (otherwise it is virtual).

Implements casacore::BaseColumn.

## isWritable()

virtual Bool casacore::RefColumn::isWritable | ( |  | ) | const

virtual

Test if the column is writable in the parent table.

Implements casacore::BaseColumn.

## keywordSet()

virtual TableRecord & casacore::RefColumn::keywordSet | ( |  | ) |

virtual

Implements casacore::BaseColumn.

## makeSortKey()

virtual void casacore::RefColumn::makeSortKey | ( | Sort & | ,
|  | std::shared_ptr< BaseCompare > & | cmpObj,
|  | Int | order,
|  | std::shared_ptr< ArrayBase > & | dataSave )

virtual

Add this column and its data to the Sort object.

It may allocate some storage on the heap, which will be saved in the argument dataSave. The function freeSortKey must be called to free this storage.

Reimplemented from casacore::BaseColumn.

References casacore::order().

## ndim()

virtual uInt casacore::RefColumn::ndim | ( | rownr_t | rownr | ) | const

virtual

Get the #dimensions of an array in a particular cell.

Reimplemented from casacore::BaseColumn.

## ndimColumn()

virtual uInt casacore::RefColumn::ndimColumn | ( |  | ) | const

virtual

Get the global #dimensions of an array (i.e.

for all rows).

Reimplemented from casacore::BaseColumn.

## nrow()

virtual rownr_t casacore::RefColumn::nrow | ( |  | ) | const

virtual

Get nr of rows in the column.

Implements casacore::BaseColumn.

## put()

virtual void casacore::RefColumn::put | ( | rownr_t | rownr,
|  | const void * | dataPtr )

virtual

Put the value in a particular cell.

This can be a scalar or an array.

Reimplemented from casacore::BaseColumn.

## putArray()

virtual void casacore::RefColumn::putArray | ( | rownr_t | rownr,
|  | const ArrayBase & | dataPtr )

virtual

Put the array value in a particular cell.

Reimplemented from casacore::BaseColumn.

## putArrayColumn()

virtual void casacore::RefColumn::putArrayColumn | ( | const ArrayBase & | dataPtr | ) |

virtual

Put the array of all array values in the column.

If the column contains n-dim arrays, the source array is (n+1)-dim. The arrays in the column have to have the same shape in all cells.

Reimplemented from casacore::BaseColumn.

## putArrayColumnCells()

virtual void casacore::RefColumn::putArrayColumnCells | ( | const RefRows & | rownrs,
|  | const ArrayBase & | dataPtr )

virtual

Get the array of some array values in a column.

If the column contains n-dim arrays, the resulting array is (n+1)-dim. The arrays in the column have to have the same shape in all cells.

Reimplemented from casacore::BaseColumn.

## putColumnSlice()

virtual void casacore::RefColumn::putColumnSlice | ( | const Slicer & | ,
|  | const ArrayBase & | dataPtr )

virtual

Put into subsections of all table arrays in the column.

If the column contains n-dim arrays, the source array is (n+1)-dim. The arrays in the column have to have the same shape in all cells.

Reimplemented from casacore::BaseColumn.

## putColumnSliceCells()

virtual void casacore::RefColumn::putColumnSliceCells | ( | const RefRows & | rownrs,
|  | const Slicer & | ,
|  | const ArrayBase & | dataPtr )

virtual

Put subsections of some arrays in the column.

If the column contains n-dim arrays, the source array is (n+1)-dim. The arrays in the column have to have the same shape in all cells.

Reimplemented from casacore::BaseColumn.

## putScalarColumn()

virtual void casacore::RefColumn::putScalarColumn | ( | const ArrayBase & | dataPtr | ) |

virtual

Put the vector of all scalar values in the column.

Reimplemented from casacore::BaseColumn.

## putScalarColumnCells()

virtual void casacore::RefColumn::putScalarColumnCells | ( | const RefRows & | rownrs,
|  | const ArrayBase & | dataPtr )

virtual

Get the vector of some scalar values in a column.

Reimplemented from casacore::BaseColumn.

## putSlice()

virtual void casacore::RefColumn::putSlice | ( | rownr_t | rownr,
|  | const Slicer & | ,
|  | const ArrayBase & | dataPtr )

virtual

Put a slice of an N-dimensional array in a particular cell.

Reimplemented from casacore::BaseColumn.

## rwKeywordSet()

virtual TableRecord & casacore::RefColumn::rwKeywordSet | ( |  | ) |

virtual

Get access to the column keyword set.

This is the keyword set in the referenced column.

Implements casacore::BaseColumn.

## setMaximumCacheSize()

virtual void casacore::RefColumn::setMaximumCacheSize | ( | uInt | nbytes | ) |

virtual

Set the maximum cache size (in bytes) to be used by a storage manager.

Implements casacore::BaseColumn.

## setShape() [1/2]

virtual void casacore::RefColumn::setShape | ( | rownr_t | rownr,
|  | const IPosition & | shape )

virtual

Set the shape of the array in the given row.

Reimplemented from casacore::BaseColumn.

References shape().

## setShape() [2/2]

virtual void casacore::RefColumn::setShape | ( | rownr_t | rownr,
|  | const IPosition & | shape,
|  | const IPosition & | tileShape )

virtual

Set the shape and tile shape of the array in the given row.

Reimplemented from casacore::BaseColumn.

References shape(), and casacore::BaseColumn::tileShape().

## shape()

virtual IPosition casacore::RefColumn::shape | ( | rownr_t | rownr | ) | const

virtual

Get the shape of an array in a particular cell.

Reimplemented from casacore::BaseColumn.

Referenced by setShape(), and setShape().

## shapeColumn()

virtual IPosition casacore::RefColumn::shapeColumn | ( |  | ) | const

virtual

Get the global shape of an array (i.e.

for all rows).

Reimplemented from casacore::BaseColumn.

## Member Data Documentation

## colCache_p

ColumnCache casacore::RefColumn::colCache_p

protected

Definition at line 248 of file RefColumn.h.

## colPtr_p

BaseColumn* casacore::RefColumn::colPtr_p

protected

Definition at line 247 of file RefColumn.h.

## refTabPtr_p

RefTable* casacore::RefColumn::refTabPtr_p

protected

Definition at line 246 of file RefColumn.h.

The documentation for this class was generated from the following file:

- tables/Tables/RefColumn.h